#include <stdlib.h>

template <class T>
struct node
{
  node() {next = NULL;}
  T item;
  node<T> * next;
};

template <class T>
class LList
{
  public:
    int size;
    node<T> * head;
    LList()
    {
      head = NULL;
      size = 0;
    }
    ~LList()
    {
      node<T> * temp = head, * current;
      while (temp != NULL)
      {
        current = temp->next;
        delete temp;
        temp = current;
      }
    }
    void insert(T item, bool type) // type: 0 is first O(1), 1 is last O(n)
    {
      if (type == 0)
      {
        node<T> * temp = head;
        head = new node<T>;
        head->item = item;
        head->next = temp;
      }
      else if (type == 1)
      {
        if (head == NULL)
        {
          head = new node<T>;
          head->item = item;
          head->next = NULL;
        }
        else
        {
          node<T> * temp = head;
          while (temp->next != NULL) temp = temp->next;
          temp->next = new node<T>;
          temp->next->item = item;
          temp->next->next = NULL;
        }
      }
      size++;
    }
    void remove(T item)
    {
      node<T> * current = head, * prev;
      while (current != NULL && !(item.equal(current->item)))
      {
        prev = current; current = current->next;
      }
      if (current != NULL)
      {
        if (prev == head)
        {
          head = current->next;
          delete current;
        }
        else
        {
          prev->next = current->next;
          delete current;
        }
        size--;
      }
    }
};

template <class T>
class LListIter
{
  public:
    LListIter(LList<T> & target)
    {
      head = target.head;
      current = head;
    }
    bool atEnd()
    {
      if (current == NULL) return 1;
      else return 0;
    }
    void reset()
    {
      current = head;
    }
    T item()
    {
      return current->item;
    }
    T * itemptr()
    {
      return &(current->item);
    }
    void step()
    {
      current = current->next;
    }
    node<T> * current;
    node<T> * head;
};
