#include <fstream.h>

class povout
{
  public:
    povout(char * filename)
    {
      fout = new ofstream(filename);
    }
    ~povout()
    {
      (*fout).close();
    }
    void setup(particle camera, particle focus, particle light, char * lightstyle, char * bgstyle)
    {
      (*fout) << "#include \"colors.inc\"" << endl;
      (*fout) << "camera { location <" << camera.x << ", " << camera.y << ", " << camera.z << "> look_at <" << focus.x <<", " << focus.y << ", " << focus.z << "> }"<< endl;
      (*fout) << "background { " << bgstyle << " }"<< endl;
      (*fout) << "light_source { <" << light.x << ", " << light.y << ", " << light.z << "> " << lightstyle << " }" << endl;
    }
    void sphere(particle a, float r, char * style)
    {
      (*fout) << "sphere { <" << a.x << ", " << a.y << ", " << a.z << ">, " << r << " " << style << " }" << endl;
    }
    void triangle(particle a, particle b, particle c, char * style)
    {
      (*fout) << "polygon { 4, <" << a.x << ", " << a.y << ", " << a.z << ">, <" << b.x << ", " << b.y << ", " << b.z << ">, <" << c.x << ", " << c.y << ", " << c.z << ">, <" << a.x << ", " << a.y << ", " << a.z << "> " << style << " }" << endl;
    }
    void cylinder(particle a, particle b, float r, char * style)
    {
      (*fout) << "cylinder { <" << a.x << ", " << a.y << ", " << a.z << ">, <" << b.x << ", " << b.y << ", " << b.z << ">, " << r << " " << style << " }" << endl;
    }
  private:
    ofstream * fout;
};
